//
// util.h
//

typedef unsigned int uint16;
typedef unsigned long uint32;

extern void InitTC1(void);
extern void EnableTC1(void);
extern void AppTimer1Stuff(void);

//
// These functions work only if TC1 is active
//
extern void delayHalfSecond(void);
extern void delay100msecs(void);
extern void delay300msecs(void);
extern void delayOneSecond(void);
extern void FlashLed(uint8 duration, uint8 cnt);
extern void BlinkFastNoInts(void);
extern void BlinkFast(void);
extern void ShortBlinkFast(void);
extern void BlinkSlow(void);

extern void PrintfEndOfLine(void);
extern void PrintfU4(uint8 Data);
extern void Printfuint8(uint8 Data);
extern void Printfu16(uint Data);
extern void Printfuint(uint Data);

extern volatile uint8 Timer1Counter2;

#if DEBUG
extern void assertFailed(const char* str, int line);
#define ASSERT(_x) if (!(_x)) assertFailed(NULL,__LINE__);
#else
#define ASSERT(_x)
#endif

#if USE_LED
#define LED_ON sbi(LEDO,LED_BIT);			// LED on
#define LED_OFF cbi(LEDO,LED_BIT)			// LED off
//#define LED_ON cbi(LEDO,LED_BIT)			// LED on for STK600
//#define LED_OFF sbi(LEDO,LED_BIT)			// LED off for STK600
#define LED2_ON sbi(LEDO,LED2_BIT)			// LED2 on for STK600
#define LED2_OFF cbi(LEDO,LED2_BIT)			// LED2 off for STK600
//#define LED2_ON cbi(LEDO,LED2_BIT)			// LED2 on for STK600
//#define LED2_OFF sbi(LEDO,LED2_BIT)			// LED2 off for STK600
#else
#define LED_ON
#define LED_OFF
#endif
